OGRE: Ogre::BillboardChain Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::BillboardChain Class Reference

Allows the rendering of a chain of connected billboards. More...

`#include <OgreBillboardChain.h>`

Inheritance diagram for Ogre::BillboardChain:

[legend]
List of all members.

## Public Types

typedef std::vector< Element > | ElementList
enum | TexCoordDirection { TCD_U, TCD_V }
| The direction in which texture coordinates from elements of the chain are used. More...
typedef std::vector< ShadowRenderable * > | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator

## Public Member Functions

| BillboardChain (const String &name, size_t maxElements=20, size_t numberOfChains=1, bool useTextureCoords=true, bool useColours=true, bool dynamic=true)
| Constructor (don't use directly, use factory).
virtual | ~BillboardChain ()
| destructor
virtual void | setMaxChainElements (size_t maxElements)
| Set the maximum number of chain elements per chain.
virtual size_t | getMaxChainElements (void) const
| Get the maximum number of chain elements per chain.
virtual void | setNumberOfChains (size_t numChains)
| Set the number of chain segments (this class can render multiple chains at once using the same material).
virtual size_t | getNumberOfChains (void) const
| Get the number of chain segments (this class can render multiple chains at once using the same material).
virtual void | setUseTextureCoords (bool use)
| Sets whether texture coordinate information should be included in the final buffers generated.
virtual bool | getUseTextureCoords (void) const
| Gets whether texture coordinate information should be included in the final buffers generated.
virtual void | setTextureCoordDirection (TexCoordDirection dir)
| Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.
virtual TexCoordDirection | getTextureCoordDirection (void)
| Gets the direction in which texture coords specified on each element are deemed to run.
virtual void | setOtherTextureCoordRange (Real start, Real end)
| Set the range of the texture coordinates generated across the width of the chain elements.
virtual const Real * | getOtherTextureCoordRange (void) const
| Get the range of the texture coordinates generated across the width of the chain elements.
virtual void | setUseVertexColours (bool use)
| Sets whether vertex colour information should be included in the final buffers generated.
virtual bool | getUseVertexColours (void) const
| Gets whether vertex colour information should be included in the final buffers generated.
virtual void | setDynamic (bool dyn)
| Sets whether or not the buffers created for this object are suitable for dynamic alteration.
virtual bool | getDynamic (void) const
| Gets whether or not the buffers created for this object are suitable for dynamic alteration.
virtual void | addChainElement (size_t chainIndex, const Element &billboardChainElement)
| Add an element to the 'head' of a chain.
virtual void | removeChainElement (size_t chainIndex)
| Remove an element from the 'tail' of a chain.
virtual void | updateChainElement (size_t chainIndex, size_t elementIndex, const Element &billboardChainElement)
| Update the details of an existing chain element.
virtual const Element & | getChainElement (size_t chainIndex, size_t elementIndex) const
| Get the detail of a chain element.
virtual void | clearChain (size_t chainIndex)
| Remove all elements of a given chain (but leave the chain intact).
virtual void | clearAllChains (void)
| Remove all elements from all chains (but leave the chains themselves intact).
virtual const String & | getMaterialName (void) const
| Get the material name in use.
virtual void | setMaterialName (const String &name)
| Set the material name to use for rendering.
void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
Real | getSquaredViewDepth (const Camera *cam) const
| Returns the camera-relative squared depth of this renderable.
Real | getBoundingRadius (void) const
| Retrieves the radius of the origin-centered bounding sphere for this object.
const AxisAlignedBox & | getBoundingBox (void) const
| Retrieves the local axis-aligned bounding box for this object.
const MaterialPtr & | getMaterial (void) const
| Retrieves a weak reference to the material this renderable object uses.
const String & | getMovableType (void) const
| Returns the type name of this object.
void | _updateRenderQueue (RenderQueue *)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | getRenderOperation (RenderOperation &)
| Gets the render operation required to send this object to the frame buffer.
void | getWorldTransforms (Matrix4 *) const
| Gets the world transform matrix / matrices for this renderable object.
const Quaternion & | getWorldOrientation (void) const

Gets the worldspace orientation of this renderable; this is used in order to more efficiently update parameters to vertex & fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling.

const Vector3 & | getWorldPosition (void) const

Gets the worldspace position of this renderable; this is used in order to more efficiently update parameters to vertex & fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling.

const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserObject (UserDefinedObject *obj)
| Call this to associate your own custom user object instance with this MovableObject.
virtual UserDefinedObject * | getUserObject (void)
| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
EdgeData * | getEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
bool | hasEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDist, unsigned long flags=0)
| Define a default implementation of method from ShadowCaster which implements no shadows.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getNormaliseNormals (void) const
| Returns whether or not this Renderable wishes the hardware to normalise normals.
virtual const PlaneList & | getClipPlanes () const
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

## Static Public Member Functions

static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Protected Types

typedef std::vector< ChainSegment > | ChainSegmentList
typedef std::map< String, StringVector > | AnimableDictionaryMap
typedef std::map< size_t, Vector4 > | CustomParameterMap

## Protected Member Functions

virtual void | setupChainContainers (void)
| Setup the STL collections.
virtual void | setupVertexDeclaration (void)
| Setup vertex declaration.
virtual void | setupBuffers (void)
virtual void | updateVertexBuffer (Camera *cam)
| Update the contents of the vertex buffer.
virtual void | updateIndexBuffer (void)
| Update the contents of the index buffer.
virtual void | updateBoundingBox (void) const
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper moethod for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.

## Protected Attributes

size_t | mMaxElementsPerChain
| Maximum length of each chain.
size_t | mChainCount
| Number of chains.
bool | mUseTexCoords
| Use texture coords?
bool | mUseVertexColour
| Use vertex colour?
bool | mDynamic
| Dynamic use?
VertexData * | mVertexData
| Vertex data.
IndexData * | mIndexData
| Index data (to allow multiple unconnected chains).
bool | mVertexDeclDirty
| Is the vertex declaration dirty?
bool | mBuffersNeedRecreating
| Do the buffers need recreating?
bool | mBoundsDirty
| Do the bounds need redefining?
bool | mIndexContentDirty
| Is the index buffer dirty?
AxisAlignedBox | mAABB
| AABB.
Real | mRadius
| Bounding radius.
String | mMaterialName
| Material.
MaterialPtr | mMaterial
TexCoordDirection | mTexCoordDir
| Tetxure coord direction.
Real | mOtherTexCoordRange [2]
| Other texture coord range.
ElementList | mChainElementList
| The list holding the chain elements.
ChainSegmentList | mChainSegmentList
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
Any | mUserAny
| User defined link to another object / value / whatever.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView

## Static Protected Attributes

static const size_t | SEGMENT_EMPTY
| Chain segment has no elements.
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.
static const PlaneList | msDummyPlaneList

## Classes

struct | ChainSegment
| Simple struct defining a chain segment by referencing a subset of the preallocated buffer (which will be mMaxElementsPerChain * mChainCount long), by it's chain index, and a head and tail value which describe the current chain. More...
class | Element
| Contains the data of an element of the BillboardChain. More...

## Detailed Description

Allows the rendering of a chain of connected billboards.

Remarks:
  A billboard chain operates much like a traditional billboard, ie its segments always face the camera; the difference being that instead of a set of disconnected quads, the elements in this class are connected together in a chain which must always stay in a continuous strip. This kind of effect is useful for creating effects such as trails, beams, lightning effects, etc.

  A single instance of this class can actually render multiple separate chain segments in a single render operation, provided they all use the same material. To clarify the terminology: a 'segment' is a separate sub-part of the chain with its own start and end (called the 'head' and the 'tail'. An 'element' is a single position / colour / texcoord entry in a segment. You can add items to the head of a chain, and remove them from the tail, very efficiently. Each segment has a max size, and if adding an element to the segment would exceed this size, the tail element is automatically removed and re-used as the new item on the head.

  This class has no auto-updating features to do things like alter the colour of the elements or to automatically add / remove elements over time - you have to do all this yourself as a user of the class. Subclasses can however be used to provide this kind of behaviour automatically.

See also:
  RibbonTrail

Definition at line 70 of file OgreBillboardChain.h.

## Member Typedef Documentation

typedef std::map<String, StringVector> Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

| Definition at line 206 of file OgreAnimable.h.

typedef std::vector<ChainSegment> Ogre::BillboardChain::ChainSegmentList`[protected]`

| Definition at line 303 of file OgreBillboardChain.h.

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

| Definition at line 285 of file OgreRenderable.h.

typedef std::vector<Element> Ogre::BillboardChain::ElementList

| Definition at line 96 of file OgreBillboardChain.h.

typedef std::vector<ShadowRenderable*> Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

| Definition at line 127 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

| Definition at line 128 of file OgreShadowCaster.h.

## Member Enumeration Documentation

enum Ogre::BillboardChain::TexCoordDirection

The direction in which texture coordinates from elements of the chain are used.

Enumeration values:

  TCD_U | Tex coord in elements is treated as the 'u' texture coordinate.
  TCD_V | Tex coord in elements is treated as the 'v' texture coordinate.

Definition at line 141 of file OgreBillboardChain.h.

## Constructor & Destructor Documentation

Ogre::BillboardChain::BillboardChain | ( | const String & | name,
|  | size_t | maxElements = `20`,
|  | size_t | numberOfChains = `1`,
|  | bool | useTextureCoords = `true`,
|  | bool | useColours = `true`,
|  | bool | dynamic = `true`
| ) |

Constructor (don't use directly, use factory).

Parameters:

  | name | The name to give this object
  | maxElements | The maximum number of elements per chain
  | numberOfChains | The number of separate chain segments contained in this object
  | useTextureCoords | If true, use texture coordinates from the chain elements
  | useVertexColours | If true, use vertex colours from the chain elements
  | dynamic | If true, buffers are created with the intention of being updated

virtual Ogre::BillboardChain::~BillboardChain | ( |  | ) | `[virtual]`

| destructor

## Member Function Documentation

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

| Get an updateable reference to animable value list. Definition at line 232 of file OgreAnimable.h. References OGRE_EXCEPT.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

| Get the creator of this object, if any (internal use only). Definition at line 166 of file OgreMovableObject.h.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

| Get the manager of this object, if any (internal use only). Definition at line 170 of file OgreMovableObject.h.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

| return the full transformation of the parent sceneNode or the attachingPoint node

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false`
| ) | `[virtual, inherited]`

| Internal method called to notify the object that it has been attached to a node. Reimplemented in Ogre::Entity, Ogre::Light, and Ogre::ParticleSystem.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

| Notify the object of it's creator (internal use only). Definition at line 164 of file OgreMovableObject.h.

void Ogre::BillboardChain::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual]`

Internal method to notify the object of the camera to be used for the next rendering operation.

Remarks:
  Certain objects may want to do specific processing based on the camera position. This method notifies them incase they wish to do this.

Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

| Notify the object of it's manager (internal use only). Definition at line 168 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) | `[virtual, inherited]`

| Internal method called to notify the object that it has been moved. Reimplemented in Ogre::Light.

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) | const`[virtual, inherited]`

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks:
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::SubEntity.

Definition at line 252 of file OgreRenderable.h.

void Ogre::BillboardChain::_updateRenderQueue | ( | RenderQueue * |  | ) | `[virtual]`

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks:
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

virtual void Ogre::BillboardChain::addChainElement | ( | size_t | chainIndex,
|  | const Element & | billboardChainElement
| ) | `[virtual]`

Add an element to the 'head' of a chain.

Remarks:
  If this causes the number of elements to exceed the maximum elements per chain, the last element in the chain (the 'tail') will be removed to allow the additional element to be added.

Parameters:

  | chainIndex | The index of the chain
  | billboardChainElement | The details to add

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 338 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 366 of file OgreMovableObject.h.

virtual void Ogre::BillboardChain::clearAllChains | ( | void |  | ) | `[virtual]`

| Remove all elements from all chains (but leave the chains themselves intact).

virtual void Ogre::BillboardChain::clearChain | ( | size_t | chainIndex | ) | `[virtual]`

| Remove all elements of a given chain (but leave the chain intact). Reimplemented in Ogre::RibbonTrail.

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

| Internal method for creating a dictionary of animable value names for the class, if it does not already exist. Definition at line 219 of file OgreAnimable.h.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

Create a reference-counted AnimableValuePtr for the named value.

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 285 of file OgreAnimable.h.

References OGRE_EXCEPT.

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | const`[protected, virtual, inherited]`

Utility method for extruding a bounding box.

Parameters:

  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | `[static, inherited]`

Utility method for extruding vertices based on a light.

Remarks:
  Unfortunately, because D3D cannot handle homogenous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this.

Parameters:

  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, ie the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags
| ) | `[protected, virtual, inherited]`

Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.

Parameters:

  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

Get the name of the animable dictionary for this class.

Remarks:
  Subclasses must override this if they want to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 214 of file OgreAnimable.h.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

| Gets a list of animable value names for this object. Definition at line 260 of file OgreAnimable.h. References OGRE_EXCEPT.

const AxisAlignedBox& Ogre::BillboardChain::getBoundingBox | ( | void |  | ) | const`[virtual]`

Retrieves the local axis-aligned bounding box for this object.

Remarks:
  This bounding box is in local coordinates.

Implements Ogre::MovableObject.

Real Ogre::BillboardChain::getBoundingRadius | ( | void |  | ) | const`[virtual]`

| Retrieves the radius of the origin-centered bounding sphere for this object. Implements Ogre::MovableObject.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether shadow casting is enabled for this object. Implements Ogre::ShadowCaster. Definition at line 442 of file OgreMovableObject.h.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 187 of file OgreRenderable.h.

virtual const Element& Ogre::BillboardChain::getChainElement | ( | size_t | chainIndex,
|  | size_t | elementIndex
| ) | const`[virtual]`

Get the detail of a chain element.

Parameters:

  | chainIndex | The index of the chain
  | elementIndex | The element index within the chain, measured from the 'head' of the chain

virtual const PlaneList& Ogre::Renderable::getClipPlanes | ( |  | ) | const`[virtual, inherited]`

| Definition at line 179 of file OgreRenderable.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

Gets the custom value associated with this Renderable at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

Definition at line 213 of file OgreRenderable.h.

References OGRE_EXCEPT.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist
| ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

| Get the default query flags for all future MovableObject instances. Definition at line 353 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

| Get the default visibility flags for all future MovableObject instances. Definition at line 381 of file OgreMovableObject.h.

virtual bool Ogre::BillboardChain::getDynamic | ( | void |  | ) | const`[virtual]`

| Gets whether or not the buffers created for this object are suitable for dynamic alteration. Definition at line 189 of file OgreBillboardChain.h.

EdgeData* Ogre::MovableObject::getEdgeList | ( | void |  | ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region. Definition at line 415 of file OgreMovableObject.h.

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light
| ) | const`[protected, inherited]`

| Helper moethod for calculating extrusion distance.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

const LightList& Ogre::BillboardChain::getLights | ( | void |  | ) | const`[virtual]`

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks:
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current listener for this object. Definition at line 392 of file OgreMovableObject.h.

const MaterialPtr& Ogre::BillboardChain::getMaterial | ( | void |  | ) | const`[virtual]`

Retrieves a weak reference to the material this renderable object uses.

Remarks:
  Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implements Ogre::Renderable.

virtual const String& Ogre::BillboardChain::getMaterialName | ( | void |  | ) | const`[virtual]`

| Get the material name in use. Definition at line 226 of file OgreBillboardChain.h.

virtual size_t Ogre::BillboardChain::getMaxChainElements | ( | void |  | ) | const`[virtual]`

| Get the maximum number of chain elements per chain. Definition at line 116 of file OgreBillboardChain.h.

const String& Ogre::BillboardChain::getMovableType | ( | void |  | ) | const`[virtual]`

| Returns the type name of this object. Implements Ogre::MovableObject. Reimplemented in Ogre::RibbonTrail.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

| Returns the name of this object. Reimplemented in Ogre::Camera. Definition at line 173 of file OgreMovableObject.h.

virtual bool Ogre::Renderable::getNormaliseNormals | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this Renderable wishes the hardware to normalise normals. Reimplemented in Ogre::SubEntity. Definition at line 171 of file OgreRenderable.h.

virtual size_t Ogre::BillboardChain::getNumberOfChains | ( | void |  | ) | const`[virtual]`

| Get the number of chain segments (this class can render multiple chains at once using the same material). Definition at line 124 of file OgreBillboardChain.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of world transform matrices this renderable requires.

Remarks:
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 111 of file OgreRenderable.h.

virtual const Real* Ogre::BillboardChain::getOtherTextureCoordRange | ( | void |  | ) | const`[virtual]`

| Get the range of the texture coordinates generated across the width of the chain elements. Definition at line 167 of file OgreBillboardChain.h.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the scene node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[virtual, inherited]`

| Get the distance to extrude for a point/spot light. Implements Ogre::ShadowCaster.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Reimplemented in Ogre::BorderRenderable. Definition at line 277 of file OgreRenderable.h.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the query flags relevant for this object. Definition at line 345 of file OgreMovableObject.h.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

| Gets the distance at which batches are no longer rendered. Definition at line 278 of file OgreMovableObject.h.

void Ogre::BillboardChain::getRenderOperation | ( | RenderOperation & |  | ) | `[virtual]`

| Gets the render operation required to send this object to the frame buffer. Implements Ogre::Renderable.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

| Gets the queue group for this entity, see setRenderQueueGroup for full details.

ShadowRenderableListIterator Ogre::MovableObject::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDist,
|  | unsigned long | flags = `0`
| ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Real Ogre::BillboardChain::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[virtual]`

Returns the camera-relative squared depth of this renderable.

Remarks:
  Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result.

Implements Ogre::Renderable.

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a pointer to the Material Technique this renderable object uses.

Remarks:
  This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 73 of file OgreRenderable.h.

virtual TexCoordDirection Ogre::BillboardChain::getTextureCoordDirection | ( | void |  | ) | `[virtual]`

| Gets the direction in which texture coords specified on each element are deemed to run. Definition at line 156 of file OgreBillboardChain.h.

virtual uint32 Ogre::MovableObject::getTypeFlags | ( | void |  | ) | const`[virtual, inherited]`

Get the 'type flags' for this MovableObject.

Remarks:
  A type flag identifies the type of the MovableObject as a bitpattern. This is used for categorical inclusion / exclusion in SceneQuery objects. By default, this method returns all ones for objects not created by a MovableObjectFactory (hence always including them); otherwise it returns the value assigned to the MovableObjectFactory. Custom objects which don't use MovableObjectFactory will need to override this if they want to be included in queries.

Reimplemented in Ogre::BillboardSet, Ogre::Entity, Ogre::Light, Ogre::ParticleSystem, and Ogre::StaticGeometry::Region.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityProjection

Definition at line 136 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityView

Definition at line 161 of file OgreRenderable.h.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves the custom user value associated with this object. Definition at line 306 of file OgreMovableObject.h.

virtual UserDefinedObject* Ogre::MovableObject::getUserObject | ( | void |  | ) | `[virtual, inherited]`

| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject. Definition at line 290 of file OgreMovableObject.h.

virtual bool Ogre::BillboardChain::getUseTextureCoords | ( | void |  | ) | const`[virtual]`

| Gets whether texture coordinate information should be included in the final buffers generated. Definition at line 136 of file OgreBillboardChain.h.

virtual bool Ogre::BillboardChain::getUseVertexColours | ( | void |  | ) | const`[virtual]`

| Gets whether vertex colour information should be included in the final buffers generated. Definition at line 179 of file OgreBillboardChain.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the visibility flags relevant for this object. Definition at line 373 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

Gets this object whether to be visible or not, if it has a renderable component.

Remarks:
  Returns the value set by MovableObject::setVisible only.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the axis-aligned bounding box for this object in world coordinates. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the worldspace bounding sphere for this object. Reimplemented in Ogre::Entity.

const Quaternion& Ogre::BillboardChain::getWorldOrientation | ( | void |  | ) | const`[virtual]`

Gets the worldspace orientation of this renderable; this is used in order to more efficiently update parameters to vertex & fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling.

Implements Ogre::Renderable.

const Vector3& Ogre::BillboardChain::getWorldPosition | ( | void |  | ) | const`[virtual]`

Gets the worldspace position of this renderable; this is used in order to more efficiently update parameters to vertex & fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling.

Implements Ogre::Renderable.

void Ogre::BillboardChain::getWorldTransforms | ( | Matrix4 * |  | ) | const`[virtual]`

Gets the world transform matrix / matrices for this renderable object.

Remarks:
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate xform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note:
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also:
  Matrix4::isAffine.

Implements Ogre::Renderable.

bool Ogre::MovableObject::hasEdgeList | ( | void |  | ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region. Definition at line 417 of file OgreMovableObject.h.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters. Reimplemented in Ogre::Light. Definition at line 252 of file OgreAnimable.h.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

Returns whether or not this object is supposed to be visible or not.

Remarks:
  Takes into account both upper rendering distance and visible flag.

Reimplemented in Ogre::InstancedGeometry::BatchInstance, and Ogre::StaticGeometry::Region.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks:
  By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also:
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns:
  The list of lights use to lighting this object.

virtual void Ogre::BillboardChain::removeChainElement | ( | size_t | chainIndex | ) | `[virtual]`

Remove an element from the 'tail' of a chain.

Parameters:

  | chainIndex | The index of the chain

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 342 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 370 of file OgreMovableObject.h.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

Sets whether or not this object will cast shadows.

Remarks:
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note:
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

Definition at line 440 of file OgreMovableObject.h.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) | `[inherited]`

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.

Definition at line 204 of file OgreRenderable.h.

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default query flags for all future MovableObject instances. Definition at line 349 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default visibility flags for all future MovableObject instances. Definition at line 377 of file OgreMovableObject.h.

virtual void Ogre::BillboardChain::setDynamic | ( | bool | dyn | ) | `[virtual]`

| Sets whether or not the buffers created for this object are suitable for dynamic alteration.

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this object.

Remarks:
  Note for size and performance reasons only one listener per object is allowed.

Definition at line 388 of file OgreMovableObject.h.

virtual void Ogre::BillboardChain::setMaterialName | ( | const String & | name | ) | `[virtual]`

| Set the material name to use for rendering.

virtual void Ogre::BillboardChain::setMaxChainElements | ( | size_t | maxElements | ) | `[virtual]`

| Set the maximum number of chain elements per chain. Reimplemented in Ogre::RibbonTrail.

virtual void Ogre::BillboardChain::setNumberOfChains | ( | size_t | numChains | ) | `[virtual]`

| Set the number of chain segments (this class can render multiple chains at once using the same material). Reimplemented in Ogre::RibbonTrail.

virtual void Ogre::BillboardChain::setOtherTextureCoordRange | ( | Real | start,
|  | Real | end
| ) | `[virtual]`

Set the range of the texture coordinates generated across the width of the chain elements.

Parameters:

  | start | Start coordinate, default 0.0
  | end | End coordinate, default 1.0

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters:

  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.

Definition at line 269 of file OgreRenderable.h.

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the query flags for this object.

Remarks:
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

Definition at line 334 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance at which the object is no longer rendered.

Parameters:

  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

Definition at line 272 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual, inherited]`

Sets the render queue group this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use.

Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

virtual void Ogre::BillboardChain::setTextureCoordDirection | ( | TexCoordDirection | dir | ) | `[virtual]`

Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.

Parameters:

  | dir | The direction, default is TCD_U.

virtual void Ogre::BillboardChain::setupBuffers | ( | void |  | ) | `[protected, virtual]`

virtual void Ogre::BillboardChain::setupChainContainers | ( | void |  | ) | `[protected, virtual]`

| Setup the STL collections.

virtual void Ogre::BillboardChain::setupVertexDeclaration | ( | void |  | ) | `[protected, virtual]`

| Setup vertex declaration.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

Sets whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityProjection

Definition at line 122 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

Sets whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityView

Definition at line 147 of file OgreRenderable.h.

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance.

Note:
  This value is shared with setUserObject so don't use both!

Definition at line 302 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setUserObject | ( | UserDefinedObject * | obj | ) | `[virtual, inherited]`

Call this to associate your own custom user object instance with this MovableObject.

Remarks:
  By simply making your game / application object a subclass of UserDefinedObject, you can establish a link between an OGRE instance of MovableObject and your own application classes. Call this method to establish the link.

Definition at line 286 of file OgreMovableObject.h.

virtual void Ogre::BillboardChain::setUseTextureCoords | ( | bool | use | ) | `[virtual]`

Sets whether texture coordinate information should be included in the final buffers generated.

Note:
  You must use either texture coordinates or vertex colour since the vertices have no normals and without one of these there is no source of colour for the vertices.

virtual void Ogre::BillboardChain::setUseVertexColours | ( | bool | use | ) | `[virtual]`

Sets whether vertex colour information should be included in the final buffers generated.

Note:
  You must use either texture coordinates or vertex colour since the vertices have no normals and without one of these there is no source of colour for the vertices.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the visiblity flags for this object.

Remarks:
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

Definition at line 362 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisible | ( | bool | visible | ) | `[virtual, inherited]`

Tells this object whether to be visible or not, if it has a renderable component.

Note:
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visbility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visbility changes are best done using this method; large or more longer term changes are best done by detaching.

Reimplemented in Ogre::Light.

virtual void Ogre::BillboardChain::updateBoundingBox | ( | void |  | ) | const`[protected, virtual]`

virtual void Ogre::BillboardChain::updateChainElement | ( | size_t | chainIndex,
|  | size_t | elementIndex,
|  | const Element & | billboardChainElement
| ) | `[virtual]`

Update the details of an existing chain element.

Parameters:

  | chainIndex | The index of the chain
  | elementIndex | The element index within the chain, measured from the 'head' of the chain
  | billboardChainElement | The details to set

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos
| ) | `[protected, virtual, inherited]`

Tells the caster to perform the tasks necessary to update the edge data's light listing.

Can be overridden if the subclass needs to do additional things.

Parameters:

  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

virtual void Ogre::BillboardChain::updateIndexBuffer | ( | void |  | ) | `[protected, virtual]`

| Update the contents of the index buffer.

virtual void Ogre::BillboardChain::updateVertexBuffer | ( | Camera * | cam | ) | `[protected, virtual]`

| Update the contents of the vertex buffer.

## Member Data Documentation

AxisAlignedBox Ogre::BillboardChain::mAABB`[mutable, protected]`

| AABB. Definition at line 272 of file OgreBillboardChain.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

| Hidden because of distance? Definition at line 115 of file OgreMovableObject.h.

bool Ogre::BillboardChain::mBoundsDirty`[mutable, protected]`

| Do the bounds need redefining? Definition at line 268 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mBuffersNeedRecreating`[protected]`

| Do the buffers need recreating? Definition at line 266 of file OgreBillboardChain.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

| Does this object cast shadows? Definition at line 133 of file OgreMovableObject.h.

size_t Ogre::BillboardChain::mChainCount`[protected]`

| Number of chains. Definition at line 252 of file OgreBillboardChain.h.

ElementList Ogre::BillboardChain::mChainElementList`[protected]`

| The list holding the chain elements. Definition at line 285 of file OgreBillboardChain.h.

ChainSegmentList Ogre::BillboardChain::mChainSegmentList`[protected]`

| Definition at line 304 of file OgreBillboardChain.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

| Creator of this object (if created by a factory). Definition at line 103 of file OgreMovableObject.h.

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

| Definition at line 286 of file OgreRenderable.h.

bool Ogre::BillboardChain::mDynamic`[protected]`

| Dynamic use? Definition at line 258 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mIndexContentDirty`[protected]`

| Is the index buffer dirty? Definition at line 270 of file OgreBillboardChain.h.

IndexData* Ogre::BillboardChain::mIndexData`[protected]`

| Index data (to allow multiple unconnected chains). Definition at line 262 of file OgreBillboardChain.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

| List of lights for this object. Reimplemented in Ogre::StaticGeometry::Region. Definition at line 141 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

| The last frame that this light list was updated in. Reimplemented in Ogre::StaticGeometry::Region. Definition at line 143 of file OgreMovableObject.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

| MovableObject listener - only one allowed (no list) for size & performance reasons. */. Definition at line 138 of file OgreMovableObject.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

| SceneManager holding this object (if applicable). Definition at line 105 of file OgreMovableObject.h.

MaterialPtr Ogre::BillboardChain::mMaterial`[protected]`

| Definition at line 277 of file OgreBillboardChain.h.

String Ogre::BillboardChain::mMaterialName`[protected]`

| Material. Definition at line 276 of file OgreBillboardChain.h.

size_t Ogre::BillboardChain::mMaxElementsPerChain`[protected]`

| Maximum length of each chain. Definition at line 250 of file OgreBillboardChain.h.

String Ogre::MovableObject::mName`[protected, inherited]`

| Name of this object. Reimplemented in Ogre::Camera. Definition at line 101 of file OgreMovableObject.h.

Real Ogre::BillboardChain::mOtherTexCoordRange[2]`[protected]`

| Other texture coord range. Definition at line 281 of file OgreBillboardChain.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

| Definition at line 108 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

| node to which this object is attached Definition at line 107 of file OgreMovableObject.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

| Definition at line 287 of file OgreRenderable.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

| Flags determining whether this object is included / excluded from scene queries. Definition at line 123 of file OgreMovableObject.h.

Real Ogre::BillboardChain::mRadius`[mutable, protected]`

| Bounding radius. Definition at line 274 of file OgreBillboardChain.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

| Does rendering this object disabled by listener? Definition at line 136 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

| The render queue to use when rendering this object. Definition at line 119 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

| Flags whether the RenderQueue's default should be used. Definition at line 121 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

| Static map of class name to list of animable value names. Definition at line 208 of file OgreAnimable.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

| Default query flags. Definition at line 147 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

| Default visibility flags. Definition at line 149 of file OgreMovableObject.h.

const PlaneList Ogre::Renderable::msDummyPlaneList`[static, protected, inherited]`

| Definition at line 284 of file OgreRenderable.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

| Definition at line 113 of file OgreMovableObject.h.

TexCoordDirection Ogre::BillboardChain::mTexCoordDir`[protected]`

| Tetxure coord direction. Definition at line 279 of file OgreBillboardChain.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

| Upper distance to still render. Definition at line 112 of file OgreMovableObject.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

| Definition at line 288 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

| Definition at line 289 of file OgreRenderable.h.

Any Ogre::MovableObject::mUserAny`[protected, inherited]`

| User defined link to another object / value / whatever. Definition at line 117 of file OgreMovableObject.h.

bool Ogre::BillboardChain::mUseTexCoords`[protected]`

| Use texture coords? Definition at line 254 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mUseVertexColour`[protected]`

| Use vertex colour? Definition at line 256 of file OgreBillboardChain.h.

VertexData* Ogre::BillboardChain::mVertexData`[protected]`

| Vertex data. Definition at line 260 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mVertexDeclDirty`[protected]`

| Is the vertex declaration dirty? Definition at line 264 of file OgreBillboardChain.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

| Flags determining whether this object is visible (compared to SceneManager mask). Definition at line 125 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

| Is this object visible? Definition at line 110 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

| Cached world AABB of this object. Reimplemented in Ogre::ParticleSystem. Definition at line 127 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

| Definition at line 129 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

| World space AABB of this object's dark cap. Definition at line 131 of file OgreMovableObject.h.

const size_t Ogre::BillboardChain::SEGMENT_EMPTY`[static, protected]`

| Chain segment has no elements. Definition at line 319 of file OgreBillboardChain.h.

The documentation for this class was generated from the following file:

- OgreBillboardChain.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:32 2008